<template>
	<el-container class="mainBox mainBoxHeaderNoBorder">
		<el-header class="header">
			<div class="left-panel">
				<scImport ref="scImport" :size="size" type="51" :httpDisabled="httpDisabled" title="批量导入指定预警清单" @parentParams="importUpload" @importSuccess="importSuccess">
					<template #header>
						<el-button v-auth="'warningExcludeImport'" type="primary" :size="size" plain @click="importFile" style="margin-right: 12px;">批量导入</el-button>
					</template>
					<template #download>
						<div v-auth="'warningExcludeImportTemplate'" @click="importTemplate">下载导入模版</div>
					</template>
				</scImport>
			</div>
			<div class="right-panel">

			</div>
		</el-header>
		<el-main class="nopadding">
			<div class="searchMain searchMainMarginNone">
				<scTableSearch ref="scSearch" :searchList="list.column" :paramsData="params" :searchShow="searchShow" @fetchSelectData="getSelectData" @changeHeaderData="getHeaderData"></scTableSearch>

				<div class="searchItem searchBtn" v-if="searchHeaderShow">
					<el-button :size="size" :icon="searchShow?'el-icon-ArrowUpBold':'el-icon-ArrowDownBold'" @click="searchShowClick">{{searchShow?'收起':'更多'}}</el-button>
					<el-button :size="size" type="primary" icon="el-icon-search" @click="upSearch">查询</el-button>
					<el-button :size="size" type="info" icon="el-icon-RefreshRight" @click="reset">重置</el-button>
				</div>
			</div>
			<scTable ref="table" :apiObj="list.apiObj" :column="list.column" row-key="id" @selection-change="selectionChange" @columnBack="columnBack" border stripe :size="size">
				<template #region_name="scope">
					<span v-if="scope.row.region_info">{{scope.row.region_info.region_name}}</span>
				</template>
			</scTable>
		</el-main>
	</el-container>
</template>

<script>
import {eventBus} from "@/utils/eventBus";
export default {
	name: 'exclude',
	components: {

	},
	data() {
		return {
			fieldsShow:false,
			size:'small',
			httpDisabled:false,
			dialog: {
				save: false,
				usageSave:false,
				permission: false
			},
			exportShow:false,
			list:{
				apiObj: this.$API.early.exclude.list,
				column:[],
				fields:{}
			},
			searchShow:false,
			searchHeaderShow:false,
			filterMap:{
				data:{}
			},
			selection: [],
			params: {},
			importParams:{
				is_save_repeat:false
			}
		}
	},
	provide(){
		return{
			filterUploadClick:this.filterClick,
			filterUploadParams:this.filterParams,
			filterTagClose:this.tagClose,
			filterModelParams:this.filterModelParams,
		}
	},
	watch:{
		'list.column':{
			handler(val){
				this.searchHeaderShow = val.length>0 && val.some(em=>em.is_search);
			},
			immediate:false,
			deep:true
		}
	},
	computed:{
		filterModelParams(){
			return this.filterMap
		},
	},
	methods: {
		/**
		 * 表格检索开始
		 * */
		searchClick(){
			this.fieldsShow = true;
		},
		fieldsSwitch(val){
			this.fieldsShow = val;
		},
		fieldsSearch(params){
			this.params = params;
			this.upSearch();
		},

		columnBack(val, fieldsData){
			this.list.column = val;
			this.list.fields = fieldsData;
		},
		async filterClick(item) {
			let {data, params} = item;
			let filterParams = Object.assign(this.params,params);
			this.filterMap.data = filterParams;
			let searchParams = this.$TOOL.objCopy(this.params);
			searchParams.field = ""
			if (typeof data.prop === 'string') {
				searchParams.field = data.prop;
			} else {
				searchParams.field = data.prop[0];
			}
			if (data.search_type == 'select' || data.search_type == 'checkbox') {
				await this.getField(data,searchParams);
			}
		},
		filterParams(params){
			let filterParams = Object.assign(this.params,params);
			this.filterMap.data = filterParams;
			this.upSearch();
		},
		tagClose(params){
			let filterParams = Object.assign(this.params,params);
			this.filterMap.data = filterParams;
		},
		searchShowClick(){
			this.searchShow = !this.searchShow;
			eventBus.$emit('close-all-popovers');
		},
		getHeaderData(params){
			this.params = params;
			this.filterMap.data = params;
		},
		async getSelectData(item) {
			let {data, params} = item;
			this.params = params;          // 列表需要的参数
			this.filterMap.data = params;  // 表头组件需要转 才能传的参数
			let searchParams = this.$TOOL.objCopy(params);
			searchParams.field = ""
			if (typeof data.prop === 'string') {
				searchParams.field = data.prop;
			} else {
				searchParams.field = data.prop[0];
			}
			if (data.search_type == 'select' || data.search_type == 'checkbox') {
				await this.getField(data,searchParams);
			}
		},
		async getField(data,searchParams) {
			const res = await this.$API.early.exclude.field.post(searchParams);
			if (res.code == 200) {
				if (res.data && res.data.length > 0) {
					res.data.forEach(item => {
						item.label = item[data.prop];
						item.value = item[data.prop];
					})
				}
				this.list.column.forEach(item => {
					if (item.prop == data.prop) {
						item.data = res.data;
					}
				})
			}
		},
		/** 表格检索结束 */
		//删除
		async table_del(row){
			const reqData = {ids: [row.id]};
			const res = await this.$API.early.earlyWarn.delete.post(reqData);
			if(res.code == 200){
				this.$refs.table.refresh();
				this.$message.success("删除成功");
			}
		},
		//批量删除
		async batch_del(){
			this.$confirm(`确定删除选中的 ${this.selection.length} 项吗？`, '提示', {
				type: 'warning'
			}).then(async () => {
				const loading = this.$loading();
				const params = {ids: this.selection.map(em => em.id)}
				const res = await this.$API.early.earlyWarn.delete.post(params);
				if (res.code == 200) {
					this.$refs.table.refresh()
					loading.close();
					this.$message.success("操作成功")
				}
			}).catch(() => {

			})
		},

		// 批量导入
		importFile(){
			this.$nextTick(()=>{
				this.$refs.scImport.importFile();
			})
		},
		async importTemplate() {
			const res = await this.$API.early.exclude.template.post();
			const blob = new Blob([res]);
			const text = new Date().getTime();
			const eLink = document.createElement('a');
			eLink.download = "指定预警清单导入模版_"+text+'.xlsx';
			eLink.style.display = 'none';
			eLink.href = URL.createObjectURL(blob);
			document.body.appendChild(eLink);
			eLink.click();
			URL.revokeObjectURL(eLink.href);
			document.body.removeChild(eLink);
		},
		async importUpload(params) {
			const updateOrAppend = (formData, key, value) => {
				let found = false;
				for (let [k] of formData.entries()) {
					if (k === key) {
						formData.set(k, value); // 替换已存在的值
						found = true;
						break;
					}
				}
				if (!found) {
					formData.append(key, value); // 如果没有找到，则添加新项
				}
			};
			updateOrAppend(params, 'is_save_repeat', this.importParams.is_save_repeat);

			this.httpDisabled = true;
			const res = await this.$API.early.exclude.import.post(params);
			if(res.code == 200){
				this.$refs.scImport.setAnalysisShow(true);
				this.$message.success('上传成功，开始导入数据');
			}
		},
		importSuccess(refresh){
			this.httpDisabled = false;
			if(!refresh){
				this.$refs.table.refresh()
			}
		},

		//表格选择后回调事件
		selectionChange(selection){
			this.selection = selection;
		},
		//搜索
		upSearch(){
			this.$refs.table.upData(this.params);
		},
		reset(){
			this.params = {};
			this.filterMap.data = {};
			this.$refs.scSearch.reload();
			eventBus.$emit('reset-popovers');
			this.$refs.table.reload();
		},
		//本地更新数据
		handleSaveSuccess(){
			this.$refs.table.refresh()
		},
	}
}
</script>

<style lang="scss" scoped>
.mainBox{
	padding: 0;
}
.danger{
	color: var(--el-color-danger);
}
.warning{
	color: var(--el-color-warning);
}
.success{
	color: var(--el-color-success);
}
</style>

